<h2>Accessibilité - Attestation de conformité d'ICONITO &Eacute;cole Numérique au <abbr title="Référentiel général d'accessibilité pour les administrations">RGAA</abbr></h2>

		 
<h3>Identité du déclarant</h3>

<p>CAP-TIC<br />
30-32 bd Sébastopol<br />
75004 Paris</p>

<h3>Date de la déclaration</h3>
<p>Cette déclaration a été établie le 21 Septembre 2012</p>

<h3>Règles, version et URI</h3>		 
<p>L'audit de vérification a été effectué sur la base de : <abbr title="Référentiel général d'accessibilité pour les administrations">RGAA</abbr> version 2.2.1 (recommandations de la Direction Générale de la Modernisation de l'État). Le référentiel est disponible à l'adresse suivante : <a title="Fichier PDF - 420Ko" href="http://references.modernisation.gouv.fr/sites/default/files/RGAA_v2.2.1.pdf">RGAA version 2.2.1</a></p>

<h3>Technologies utilisées sur le site</h3>
<ul>
    <li>XHTML 1.0 strict</li>
    <li>CSS</li>
    <li>Javascript</li>
    <li>Adobe Flash</li>
    <li>Php</li>
    <li>MySQL</li>
</ul>
            
<h3>Agents utilisateurs et technologies d'assistance utilisées pour vérifier l'accessibilité des contenus</h3>
<ul>
    <li>Opquast reporting</li>
    <li>Firefox 15</li>
    <li>Internet Explorer 8 et 9</li>
    <li>Safari 5</li>
    <li>Chrome 19</li>
</ul>

<h3>Pages du site ayant fait l'objet de la vérification de conformité</h3>
<p>Les adresses des pages sont fournies à titre indicatif. L'accès à certaines ressources nécessite un compte existant au sein de l'ENT et certaines ressources ne sont accessibles qu'à certains profils.</p>
<ul>
    <li><a href="{copixurl}">Accueil</a></li>
    <li><a href="{copixurl dest="kernel|dashboard|"}">Tableau d'affichage</a></li>
</ul>

<h3>R&eacute;sultat des tests</h3>
<h4>Analyse globale</h4>
<p>L'analyse du site met en  &eacute;vidence une conformit&eacute; globale de 70 % (pour un niveau A+AA). Dans le d&eacute;tail, 210 tests ont &eacute;t&eacute;  effectu&eacute;s. 92 tests sont conformes, 39 tests donnent un r&eacute;sultat non conforme.  79 crit&egrave;res sont non-applicables.</p>
<h4>R&eacute;sultats par niveau de priorit&eacute;</h4>

<table summary="R&eacute;sultats des tests par niveau de priorit&eacute;" class="viewItems">
<caption class="hiddenClean">R&eacute;sultats par niveau de priorit&eacute;</caption>
<thead>
    <tr>
        <th id="entete1" >Niveau</th>
        <th id="entete2">Nombre <br />
        de tests</th>
        <th id="entete3">Valid&eacute;s</th>
        <th id="entete4">Non<br />
        valid&eacute;s</th>
        <th id="entete5">Non Applicables<br />
        (NA)</th>
        <th id="entete6">Conformit&eacute;</th>
    </tr>
</thead>
<tbody>
<tr >
<td headers="entete1"><strong>Niveau A</strong></td>
<td headers="entete2">174</td>
<td headers="entete3">71</td>
<td headers="entete4">34</td>
<td headers="entete5">69</td>
<td headers="entete6"><strong>68&nbsp;%</strong></td>
</tr>
<tr class="even">
<td headers="entete1"><strong>Niveau AA</strong></td>
<td headers="entete2">&nbsp;36</td>
<td headers="entete3">21</td>
<td headers="entete4">5</td>
<td headers="entete5">10</td>
<td headers="entete6"><p><strong>81&nbsp;%</strong></p></td>
</tr>
<!--<tr>
<td headers="entete1"><strong>Niveau AAA</strong></td>
<td headers="entete2">65</td>
<td headers="entete3">20</td>
<td headers="entete4">20</td>
<td headers="entete5">25</td>
<td headers="entete6"><strong>50&nbsp;%</strong></td>
</tr>
--><tr>
<td headers="entete1"><strong>Total A+AA</strong></td>
<td headers="entete2">210</td>
<td headers="entete3">92</td>
<td headers="entete4">39</td>
<td headers="entete5">79</td>
<td headers="entete6"><strong>70&nbsp;%</strong></td>
</tr>
</tbody>
</table>
<h3>D&eacute;rogations et justifications        </h3>

<p>Au vu du volume très important de données, l'ensemble de l'application sera testée et cette page sera complétée au fur et à mesure.</p>
<p>Nos tests concernent uniquement l'application elle-même et non les contenus tierce partie. Les contenus ajoutés par les utilisateurs ne peuvent pas être pris en compte.</p>

<h4>Niveau A</h4>

<h5>[Structure] 3 : Absence d'interruption dans la hiérarchie de titres</h5>
<p><strong>jQuery Tooltip :</strong> L'usage de composants externes est nécessaire. Ces composants ne sont pas toujours complètement accessibles. Nous essayons de les remplacer dès la sortie d'un outil équivalent accessible.</p>

<h5>[Navigation] 16 : Absence de liens sans intitulé</h5>
<p><strong>Fancybox :</strong> L'usage de composants externes est nécessaire. Ces composants ne sont pas toujours complètement accessibles. Nous essayons de les remplacer dès la sortie d'un outil équivalent accessible.</p>
<h5>[Structure] 4 : Présence d'une hiérarchie de titres complète</h5>
<p><strong>jQuery Tooltip :</strong> L'usage de composants externes est nécessaire. Ces composants ne sont pas toujours complètement accessibles. Nous essayons de les remplacer dès la sortie d'un outil équivalent accessible.</p>

<h4>Niveau AA</h4>
<h5>[Navigation] 17 : Pr&eacute;sence d'une page contenant le plan du site.</h5>
<p>Cette application fonctionne différemment selon les profils qui y accèdent et le contenu des pages dépend du périmètre sélectionné. Un acc&egrave;s direct &agrave; toutes les pages n'est donc pas possible. Et la liste complète des liens pour l'ensemble des types d'utilisateurs peut être extrêmement complexe et évolue à minima tous les ans. Le plan du site n'a donc pas de sens dans ce contexte.
</p>

<h5>[Navigation] 34 : Pr&eacute;sence d'un moteur de recherche.</h5>
<p>Aucun module de moteur de recherche n'existe aujourd'hui.</p>








<h3>Erreur, oubli, remarque</h3>
<p>Nous nous engageons &agrave; mettre  cette application &agrave; la disposition de tout internaute, ind&eacute;pendamment de ses dispositions  physiques, cognitives, mat&eacute;rielles ou g&eacute;ographiques.</p>
<p>              Si vous constatez qu'une page ne correspond pas &agrave; ce crit&egrave;re, merci de <a href="http://www.cap-tic.fr/index.php/contact" title="nous contacter - nouvelle fen&ecirc;tre" target="_blank">nous contacter </a> </p>
